/*
 * Created on 09.03.2004
 * AttributLesenderClient
 *
*/
package theorie;

import java.util.Date;
import java.util.Properties;

import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.Part;
import javax.mail.Session;
import javax.mail.URLName;
import javax.mail.internet.InternetAddress;

/**
 * Lesen von Mail Attributen
 *
 */
public class AttributLesenderClient {
	private static final String URL = "imap://jjoller@imap.hsr.ch/INBOX";
	public static void main(String[] args) {
		System.out.println("[AttributLesenderClient]main()");
		String mail_url;
		if (args.length == 0) {
			System.err.println(
				"Usage: java AttributeClient protocol://username@host/foldername");
			//return;
			mail_url = URL;
		} else {
			mail_url = args[0];
		}
		System.out.println("[AttributLesenderClient.main()]Mailserver URL : "+mail_url);
		URLName server = new URLName(mail_url);

		try {
			System.out.println("[AttributLesenderClient.main()]Session");
			Session session =
				Session.getDefaultInstance(
					new Properties(),
					new MailAuthenticator(server.getUsername()));

			// Verbindungsaufbau, Folder ffnen
			System.out.println("[AttributLesenderClient.main()]Folder");
			Folder folder = session.getFolder(server);
			if (folder == null) {
				System.out.println(
					"Folder " + server.getFile() + " nicht gefunden.");
				System.exit(1);
			}
			folder.open(Folder.READ_ONLY);

			// Lesen der Messages auf dem Server
			System.out.println("[AttributLesenderClient.main()]Message[]");
			Message[] messages = folder.getMessages();
			for (int i = 0; i < messages.length; i++) {
				System.out.println(
					"------- Message " + (i + 1) + " ------");
				String from = InternetAddress.toString(messages[i].getFrom());
				if (from != null)
					System.out.println("From: " + from);
				String to =
					InternetAddress.toString(
						messages[i].getRecipients(Message.RecipientType.TO));
				if (to != null)
					System.out.println("To: " + to);
				String subject = messages[i].getSubject();
				if (subject != null)
					System.out.println("Subject: " + subject);
				Date sent = messages[i].getSentDate();
				if (sent != null)
					System.out.println("Sent: " + sent);

				System.out.println();
				// Attribute
				System.out.println("[AttributLesenderClient.main()]Attribute");
				System.out.println(
					"\tDie Nachricht ist ungefhr "
						+ messages[i].getSize()
						+ " Bytes lang.");
				System.out.println(
					"\tDie Nachricht umfasst ungefhr "
						+ messages[i].getLineCount()
						+ " Zeilen.");
				String disposition = messages[i].getDisposition();
				if (disposition == null); // nichts
				else if (disposition.equals(Part.INLINE)) {
					System.out.println("\tInline Anzeige");
				} else if (disposition.equals(Part.ATTACHMENT)) {
					System.out.println("\tAttachment");
					String fileName = messages[i].getFileName();
					if (fileName != null) {
						System.out.println(
							"\tDateinamen des Attachments " + fileName);
					}
				}
				String description = messages[i].getDescription();
				if (description != null) {
					System.out.println(
						"\tDescription der Nachricht " + description);
				}
			}
			// Verbindungsabbau
			// Meldungen bleiben auf dem Server
			System.out.println("[AttributLesenderClient.main()]Folder schliessen");
			folder.close(false);

		} catch (Exception e) {
			e.printStackTrace();
		}
		System.out.println("[AttributLesenderClient.main()]Ende");
		// GUI abschliessen
		// exit()
		System.exit(0);
	}

}
