/*
 * Created on 08.03.2004
 * EinfachesTextMail
 *
*/
package theorie;


/**
 * Title:        Einfaches Text Mail
 * Description:  Beispiel fr den Einsatz des JavaMail APIs.
 * Aufbau:
 * 0) setzen des Mail Hosts (ausgehende Meldungen)
 * 1) definieren und kreieren der Internet Adressen der Sender und Empfnger
 * 2) Setzen der From, To und Empfngertypus Felder (TO)
 * 3) setzen des Nachrichtentextes
 * 4) versenden der Nachricht
 */

import javax.mail.*;
import javax.mail.internet.*;
import java.util.*;

public class EinfachesTextMail {

  public static void main(String[] args) {

	Properties props = new Properties();
	props.put("mail.host", "smtp.swissonline.ch");

	try {

	  // 0) setzen des Mail Hosts (ausgehende Meldungen)
	  Session mailConnection = Session.getInstance(props, null);
	  mailConnection.setDebug(true);
	  // 1) definieren und kreieren der Internet Adressen der Sender und Empfnger
	  Address from = new InternetAddress("josef.m.joller@swissonline.ch", "Josef M. Joller");
	  Address to = new InternetAddress("joller@joller-voss.ch");

	  Message msg = new MimeMessage(mailConnection);
	  // 2) Setzen der From, To und Empfngertypus Felder (TO)
	  msg.setFrom(from);
	  msg.setRecipient(Message.RecipientType.TO, to);
	  msg.setSubject("Besuch?.");
	  // 3) setzen des Nachrichtentextes
	  msg.setContent("Der Gast aus Moskau spricht deutsch, english, schweizerisch...",
	   "text/plain");
	  // 4) versenden der Nachricht
	  Transport.send(msg);
	}
	catch (Exception e) {
	  e.printStackTrace();
	}
  }
}
