/*
 * Created on 09.03.2004
 * HeaderreaderClient
 *
*/
package theorie;

/**
 * Title:        Lesen von Mail Header Informationen
 * Description:  Einfacher Mail  Client, der die Header Informatione liest. Diese werden angezeigt. Das Programm unterscheidet sich kaum von den bisherigen, bis auf die Einschrnkung auf die Headerinfo.
 */
import java.util.Date;
import java.util.Properties;

import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.URLName;
import javax.mail.internet.InternetAddress;

public class HeaderReaderClient {
	private static final String URL="pop3://josef.m.joller@pop.swissonline.ch/inbox";
	public static void main(String[] args) {
		String serverURL;
		if (args.length == 0) {
			System.err.println(
				"Usage: java HeaderClient protocol://username@host:port/foldername");
			//return;
			serverURL=URL;
		} else serverURL=args[0];

		URLName server = new URLName(serverURL);

		try {
			System.out.println("Session wird aufgebaut");
			Session session =
				Session.getDefaultInstance(
					new Properties(),
					new MailAuthenticator(server.getUsername()));
			System.out.println("Session aufgebaut");

			// Verbindungsaufbau
			// ffnen des Folders
			System.out.println("Folder wird bestimmt");
			Folder folder = session.getFolder(server);
			if (folder == null) {
				System.out.println(
					"Folder " + server.getFile() + " not found.");
				System.exit(1);
			}
			folder.open(Folder.READ_ONLY);
			System.out.println("Folder zum Lesen geffnet");

			// Lesen der Meldungen
			System.out.println("Lesen der Meldungen");
			Message[] messages = folder.getMessages();
			System.out.println("Ausgabe der Header Informationen");
			for (int i = 0; i < messages.length; i++) {
				System.out.println(
					"------------ Message " + (i + 1) + " ------------");
				// Here's the big change...
				String from = InternetAddress.toString(messages[i].getFrom());
				if (from != null)
					System.out.println("From: " + from);
				String replyTo =
					InternetAddress.toString(messages[i].getReplyTo());
				if (replyTo != null)
					System.out.println("Reply-to: " + replyTo);
				String to =
					InternetAddress.toString(
						messages[i].getRecipients(Message.RecipientType.TO));
				if (to != null)
					System.out.println("To: " + to);
				String cc =
					InternetAddress.toString(
						messages[i].getRecipients(Message.RecipientType.CC));
				if (cc != null)
					System.out.println("Cc: " + cc);
				String bcc =
					InternetAddress.toString(
						messages[i].getRecipients(Message.RecipientType.BCC));
				if (bcc != null)
					System.out.println("Bcc: " + to);
				String subject = messages[i].getSubject();
				if (subject != null)
					System.out.println("Subject: " + subject);
				Date sent = messages[i].getSentDate();
				if (sent != null)
					System.out.println("Sent: " + sent);
				Date received = messages[i].getReceivedDate();
				if (received != null)
					System.out.println("Received: " + received);

				System.out.println();
			}
			// Schliessen der Verbindung
			// Meldungen bleiben auf dem Server
			folder.close(false);
		} catch (Exception e) {
			e.printStackTrace();
		}
		System.exit(0);
	}
}