/*
 * Created on 08.03.2004
 * ProtokollUnabhaengigerClient
 *
*/
package theorie;

/**
 * Title:        Einfacher MailClient mit URLName als Parameter
 * Description:  Universeller Client, der einen URLName String als Parameter bernimmt
*/
import java.util.Properties;

import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.URLName;

public class ProtokollUnabhaengigerClient {

	public static void main(String[] args) {
		if (args.length == 0) {
			System.err.println(
				"Usage: java MailClient protocol://username:password@host:port/foldername");
			//pop3://<<username>><<passwort>>@pop.bluewin.ch/inbox
			return;
		}

		URLName server = new URLName(args[0]);
		//URLName server = new URLName(temp);
		System.out.println("URLName festgelegt");

		try {
			System.out.println("Verbindungsaufbau");
			Session session =
				Session.getDefaultInstance(new Properties(), null);

			// Verbindung zum Server aufbauen und Folder ffnen
			Folder folder = session.getFolder(server);
			System.out.println("Verbindungsaufbau abgeschlossen");
			System.out.println("Folder oeffnen");
			if (folder == null) {
				System.out.println(
					"Folder " + server.getFile() + " nicht gefunden.");
				System.exit(1);
			}
			folder.open(Folder.READ_ONLY);
			System.out.println("Folder geoeffnet");

			// Lesen der Messages
			System.out.println("Lesen der Messages");
			Message[] messages = folder.getMessages();
			System.out.println("Messages gelesen");
			for (int i = 0; i < messages.length; i++) {
				System.out.println(
					"------------ Message " + (i + 1) + " ------------");
				messages[i].writeTo(System.out);
			}

			// Abbau der Verbindung
			// Meldungen bleiben auf dem Server
			folder.close(false);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}