/*
 * Created on 08.03.2004
 * SichererSMTPClient
 *
*/
package theorie;

/**
 * @author jjoller
 *
 */
/**
 * Title:        Sicherer POP3 Client
 * Description:  Ergnzung zum POP3 Client:
 * das Passwort und der Benutzer knnen zur Laufzeit eingegeben werden.
 */
import java.util.Properties;

import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Store;

public class SichererPOP3Client {

	public static void main(String[] args) {

		Properties props = new Properties();
		String host = "pop.swissonline.ch";
		String provider = "pop3";

		try {
			//Verbindungsaufbau
			Session session =
				Session.getDefaultInstance(props, new MailAuthenticator());
			Store store = session.getStore(provider);
			store.connect(host, null, null);

			// Folder ffnen
			Folder inbox = store.getFolder("INBOX");
			if (inbox == null) {
				System.out.println("No INBOX");
				System.exit(1);
			}
			inbox.open(Folder.READ_ONLY);

			// Mail lesen
			Message[] messages = inbox.getMessages();
			for (int i = 0; i < messages.length; i++) {
				System.out.println(
					"------------ Message " + (i + 1) + " ------------");
				messages[i].writeTo(System.out);
			}
			// Verbindungsabbau
			// Meldungen bleiben auf dem Server
			inbox.close(false);
			store.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		// explizites Verlassen des Programms
		System.exit(0);
	}
}
